// programa para java > 8, inflar (Zlib) .XML de fichero salvado de draw.io , uso c> java LeeXMLZip Circuito.xml <-|
// idea inicial de https://www.mkyong.com/java/how-to-read-xml-file-in-java-dom-parser/
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import org.w3c.dom.Element;

import java.nio.charset.StandardCharsets;
import java.util.Base64;

import java.io.File;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.zip.* ; 




public class LeeXMLZip {

	
	public static String decompress(byte[] compressed) throws IOException { // draw.io usa pako.js (basado en zlib port)
		ByteArrayInputStream bis = new ByteArrayInputStream(compressed);
		InflaterInputStream gis = new InflaterInputStream(bis); // para descomprimir ZLIB
		BufferedReader br = new BufferedReader(new InputStreamReader(gis, "UTF-8"));
		StringBuilder sb = new StringBuilder();
		String line;
		while((line = br.readLine()) != null) {
			sb.append(line);
		}
		br.close();
		gis.close();
		bis.close();
		return sb.toString();
	}

   public static String decode64(String value) throws Exception {
      byte[] decodedValue = Base64.getDecoder().decode(value);  // Basic Base64 decoding
      return new String(decodedValue, StandardCharsets.UTF_8);
   }

  public static void main(String argv[]) {
    try {
        for (String s: argv) 
         {
//       System.out.println( s);
	 File fXmlFile = new File( s); // Fichero "Circuito.xml"
  	 DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
	 DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
	 Document doc = dBuilder.parse( fXmlFile);			
	 doc.getDocumentElement().normalize();
//	 System.out.println("Raiz :" + doc.getDocumentElement().getNodeName());	// mxfile		
	 NodeList nList = doc.getElementsByTagName("diagram");			
	 for (int temp = 0; temp < nList.getLength(); temp++) {
		Node nNode = nList.item( temp);				
//		System.out.println("\nCurrent Element :" + nNode.getNodeName()); // "diagram"				
		if (nNode.getNodeType() == Node.ELEMENT_NODE) {
			Element eElement = (Element) nNode;
//			System.out.println("id =" + eElement.getAttribute("id")+" Texto="); // id =7e0a89b8-554c-2b80-1dc8-d5c74ca68de4
			String cuerpo = doc.getElementsByTagName("diagram").item(0).getTextContent(); // cuerpo
//			System.out.println( cuerpo);
                        byte[] decodedValue = Base64.getDecoder().decode( cuerpo);  // Base64 decoding string ascii to binary
//			System.out.println( decodedValue);
			String XmlUnzip= decompress( decodedValue   );
//			System.out.println( XmlUnzip );
		}
	 }
        }
    } catch (Exception e) {
	e.printStackTrace();
    }
  }
}
